
var equationBlocks=new Array(); 
var equationBlockInfo=new Array(); 
var equationIndentTracker=new Array(); 
var equationIndentLevel; 
var currentIndex=0; 
var currentSubIndex=0;
var equationPosition=0;
var equationLength=0;
var parseNegativeNumber=0;
var errorMessage=false;
var equationToCalculate;
var PDVariables=new Array();
var PDVariableNames=new Array();
var masterEquation="";
debugEquation="32*2+2*sin(1)+1/2*3+4/1*1.234+5-2*sinh(3)+2^2^3";
var functionArray=new Array('', 'exp', 'sin', 'cos', 'tan', 'sqrt', 'sinh', 'cosh', 'ln', 'log', 'tanh', 'csc', 'sec', 'cot', 'csch', 'sech', 'coth', 'asin', 'acos', 'atan', 'bin', 'cbrt', 'floor', 'ceil', 'round');
function calculateEquation(equation)
{
masterEquation=equation;
equationToCalculate=equation;
var answer={errorMessage:false, answer:'', variableStoredIn:false};
var variableToStoreAnswerIn=false, tempAnswer;
resetCalculationVariables();
if (equationToCalculate=='') {
answer.errorMessage='Nothing to calculate.';
return answer;
}
if (commaLocale) { 
equationToCalculate=equationToCalculate.replace(/,/g, '.');
}
for (i=0; i<equationToCalculate.length; i++)
equationToCalculate=equationToCalculate.replace(multiplicationDot, '*')
if (equationToCalculate.match(RegExp('\\(\\)'))) { 
answer.errorMessage='Need arguments in parenthesis.';
return answer;
}
variableToStoreAnswerIn=splitUpEquation(equationToCalculate);
if (!preferencesProgrammerMode) { 
equationToCalculate=equationToCalculate.replace(/%/g, '/(100)');
}
equationLength=equationToCalculate.length;
hashEquation();
if (errorMessage) {
answer.errorMessage=errorMessage;
return answer;
}
reduceEquation();
tempAnswer=equationBlocks[0][0].getNumber();
if (errorMessage) {
} else if (isNaN(tempAnswer)) {
errorMessage='NaN (or possibly an imaginary number).';
} else if (tempAnswer===false) {
errorMessage='NaN (or possibly very large).';
} else if (tempAnswer=="Infinity") {
errorMessage='Answer is greater than ~10^308.';
}	
if (errorMessage) {
answer.errorMessage=errorMessage;
return answer;
}
if (variableToStoreAnswerIn) {
setVariable(variableToStoreAnswerIn, tempAnswer);
answer.variableStoredIn=variableToStoreAnswerIn;
}
answer.errorMessage=errorMessage;
answer.answer=tempAnswer;
return answer;
}
function splitUpEquation()
{
var equalsLocation=equationToCalculate.indexOf('='), variableToStoreAnswerIn;
if (equalsLocation!=-1) { 
if (equalsLocation!=equationToCalculate.lastIndexOf('=')) {
errorMessage='More than one equals sign.';
return false;
}
variableToStoreAnswerIn=equationToCalculate.substring(0, equalsLocation);
equationToCalculate=equationToCalculate.substring(equalsLocation+1);
if (!isValidVariable(variableToStoreAnswerIn)) {
if (!errorMessage) { 
answer.errorMessage=variableToStoreAnswerIn + " is not a valid variable name.";
}
return false;
}
return variableToStoreAnswerIn;
}
return false;
}
function resetCalculationVariables()
{
equationBlocks=new Array();
equationBlocks[0]=new Array();
equationBlocks[0][0]=new PDBlock();
equationBlockInfo=new Array();
equationBlockInfo[0]=new PDBlockInfo();
equationIndentTracker=new Array();
equationIndentTracker[0]=new PDPosition();
equationIndentLevel=0;
equationPosition=0;
equationLength=0;
currentIndex=0;
currentSubIndex=0;
errorMessage=false;
parseNegativeNumber=0;
}
function printOutHashedEq()
{
}
function hashEquation() 
{
var keycode;
for (equationPosition=0; equationPosition<equationLength; equationPosition++) { 
keycode=equationToCalculate.charCodeAt(equationPosition);
if ((keycode>47 && keycode<58) || keycode==46) { 
parsePDNumber();
} else if (isOperator(keycode)) { 
parseOperator();
} else { 
parseFunctionOrVariable();
}
if (errorMessage) 
return false;
}
verifyBlockIndent();
}
function parseOperator()
{
var keycode=equationToCalculate.charCodeAt(equationPosition), nonLinkableOperatorCount=0;
while (isOperator(keycode)) { 
if (keycode==42 || keycode==47 || keycode==94 || keycode==37) { 
if (!nonLinkableOperatorCount) { 
addOperatorToStack(equationToCalculate.charAt(equationPosition));
} else {
errorMessage='Two operators in a row: '+masterEquation.charAt(equationPosition-1)+masterEquation.charAt(equationPosition);
return;
}
nonLinkableOperatorCount++;
} else if (keycode==41) { 
if (isDelimiter(equationToCalculate.charCodeAt(equationPosition+1)) && equationToCalculate.charCodeAt(equationPosition+1)!=40 && !nonLinkableOperatorCount) {
decrementBlockIndent();
} else {
errorMessage='Error near ' + masterEquation.charAt(equationPosition) + masterEquation.charAt(equationPosition+1);
return false;
}
} else if (keycode==40) { 
if (isDelimiter(equationToCalculate.charCodeAt(equationPosition+1)) && equationToCalculate.charCodeAt(equationPosition+1)!=40 && equationToCalculate.charCodeAt(equationPosition+1)!=43 && equationToCalculate.charCodeAt(equationPosition+1)!=45) {
errorMessage='Error near ' + masterEquation.charAt(equationPosition) + masterEquation.charAt(equationPosition+1);
return false;
} else {
incrementBlockIndent();
nonLinkableOperatorCount=0;
}
} else if (keycode==43 || keycode==45) { 		
parseNegativeSign();
if (currentBlockHasOperator()) {
if (parseNegativeNumber)  {
setBlockNegative();
} 
} else {
if (parseNegativeNumber) {
addOperatorToStack('-');
} else {
addOperatorToStack('+');
}
}
parseNegativeNumber=0;
nonLinkableOperatorCount++;
}
equationPosition++;
keycode=equationToCalculate.charCodeAt(equationPosition);
}
equationPosition--;
if ((equationPosition+1)==equationLength && equationToCalculate.charCodeAt(equationPosition)!=41) {
errorMessage=equationToCalculate.charAt(equationPosition) +' at end of formula.';
return false;
}
}
function parseFunctionOrVariable()
{
var answerNumber='';
var currentStackIndex;
var currentString, currentVariableIndex;
var functionNumber;
currentString=getStringUpToOperator();
functionNumber=parseFunction(currentString);
if (functionNumber) { 
if (equationToCalculate.charCodeAt(equationPosition+1)!=40) { 
errorMessage='Illegal character after '+ functionArray[functionNumber]+ '.';
return false;
}				
if (parseNegativeNumber) {
setBlockNegative();
parseNegativeNumber=0;
}
setBlockFunction(functionNumber);
} else { 
currentVariableIndex=getVariableIndex(currentString);
if (currentVariableIndex!=-1) { 
addVariableToStack(currentVariableIndex);
if (equationToCalculate.charCodeAt(equationPosition+1)==40) { 
errorMessage='Can\'t have ( after '+ currentString+ '.';
return false;
}					
} else { 
errorMessage=currentString + " is not a variable.";
return "";
}
}
}
function parseNegativeSign()
{
var negativeCount=0;
while (equationToCalculate.charCodeAt(equationPosition)==43 || equationToCalculate.charCodeAt(equationPosition)==45) {
if (equationToCalculate.charCodeAt(equationPosition)==45)
negativeCount++;
equationPosition++;
}
equationPosition--;
if ((negativeCount%2)) { 
parseNegativeNumber=1;
} else {
parseNegativeNumber=0;
}
}
function parseFunction(stringToParse)  
{
var i, functionArrayLength=functionArray.length;
if (!stringToParse)
return false;
for (i=1; i<functionArrayLength; i++) {
if (stringToParse==functionArray[i]) {
return i;
}
}
return false;	
}
function parsePDNumber()
{
var currentNumber=equationToCalculate.charAt(equationPosition);
var nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
var currentNumberToAdd='';
var decimalCount=0, exponentCount=0;
var masterNumber;
var typeOfNumber=0, masterNumberLength;
if (preferencesProgrammerMode) { 
if (parseProgrammerNumber()) {
return;
}
}
while ((nextCharCode>47 && nextCharCode<58) || nextCharCode==46 || nextCharCode==101 || nextCharCode==69) {
equationPosition++;
currentNumberToAdd=equationToCalculate.charAt(equationPosition);
if (currentNumberToAdd=='.') {  
decimalCount++;
if (exponentCount) {	
errorMessage='Exponent must be an integer.'; 
return;
}
} else if (currentNumberToAdd=='e' || currentNumberToAdd=='E') { 
exponentCount++;
if (equationToCalculate.charCodeAt(equationPosition+1)==45 || equationToCalculate.charCodeAt(equationPosition+1)==43 ) {
equationPosition++;
parseNegativeSign();
if (parseNegativeNumber) {
currentNumberToAdd='e-';
} else {
currentNumberToAdd='e';
}
}
if (equationToCalculate.charCodeAt(equationPosition+1)<48 || equationToCalculate.charCodeAt(equationPosition+1)>57 || (equationPosition+1)>=equationLength) { 
errorMessage='Exponent must be an integer.';
return;
}
}
currentNumber=currentNumber+''+currentNumberToAdd;
nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
} 
if (decimalCount>1) {
errorMessage='Too many decimals.';
return;
}
if (exponentCount>1) {
errorMessage='Too many exponents.';
return;
}
if (!isDelimiter(nextCharCode)) {
errorMessage="Need operator after "+currentNumber+".";
return;
}
if (currentNumber=='.') {
errorMessage=". is not a number.";
return;
}
addNumberToStack(currentNumber);
parseNegativeNumber=0;	
}
function parseProgrammerNumber()
{
var currentCharCode=equationToCalculate.charCodeAt(equationPosition);
var nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
var currentNumberToAdd='';
var currentNumber='';
var currentChar;
if (currentCharCode==48) {
if (nextCharCode==120) { 
equationPosition++;
nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
while ((nextCharCode>47 && nextCharCode<58) || (nextCharCode>64 && nextCharCode<71) || (nextCharCode>96 && nextCharCode<103)) {
equationPosition++;
currentNumberToAdd=equationToCalculate.charAt(equationPosition);
currentNumber=currentNumber+''+currentNumberToAdd;
nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
}
if (!isDelimiter(nextCharCode)) {
errorMessage="Need operator after 0x"+currentNumber+".";
return true;
}
if (currentNumber.length==0) {
errorMessage="Must have hex number after 0x.";
return true;
}
currentNumber=parseInt(currentNumber,16);
currentNumber=currentNumber.toString();
addNumberToStack(currentNumber);
parseNegativeNumber=0;	
return true;
} else if (nextCharCode>47 && nextCharCode<58) { 
while (nextCharCode>47 && nextCharCode<56) {
equationPosition++;
currentNumberToAdd=equationToCalculate.charAt(equationPosition);
currentNumber=currentNumber+''+currentNumberToAdd;
nextCharCode=equationToCalculate.charCodeAt(equationPosition+1);
}
if (nextCharCode==56 || nextCharCode==57) {
errorMessage="Octals can\'t have "+equationToCalculate.charAt(equationPosition+1)+" (near 0"+currentNumber+").";
return true;
}
if (!isDelimiter(nextCharCode)) {
errorMessage="Need operator after 0"+currentNumber+".";
return true;
}
if (currentNumber.length==0) {
errorMessage="Error near octal parsing.";
return true;
}
currentNumber=parseInt(currentNumber,8);
currentNumber=currentNumber.toString();
addNumberToStack(currentNumber);
parseNegativeNumber=0;	
return true;
}	
} 
return false;
}
function getStringUpToOperator()
{
var stringToReturn='';
while (equationPosition<=equationLength) {
if (isDelimiter(equationToCalculate.charCodeAt(equationPosition))) {
equationPosition--;
return stringToReturn;
}
stringToReturn=stringToReturn+''+equationToCalculate.charAt(equationPosition);
equationPosition++;
}
errorMessage='Parsing error. Please report with the equation.'
return false;
}
function getNumberUpToOperator()
{
var stringToReturn='';
while (equationPosition<equationLength) {
if (isDelimiter(equationToCalculate.charCodeAt(equationPosition))) {
return stringToReturn;
} else {
stringToReturn=stringToReturn+''+equationToCalculate.charAt(equationPosition);
}
equationPosition++;
}
return false;
}
function isDelimiter(operator)
{
if (isOperator(operator) || isNaN(operator)) {
return true;
}
return false;
}
function isVariableDelimiter(operator)
{
if (isDelimiter(operator) || operator==61 || operator==44 || operator==46 || operator==37 || operator==32 || operator==8901 || operator==160) 
return true;
return false;
}
function isOperator(operator)
{
if (operator==40 || operator==41 || operator==42 || operator==43 || operator==45 || operator==47 || operator==94 || operator==37)
return true;
return false;
}
function addNumberToStack(numberToAdd)
{	
(equationBlocks[currentIndex][currentSubIndex]).setNumber(numberToAdd);
addBlankBlockToCurrentStack();
}
function addVariableToStack(currentVariableIndex)
{	
(equationBlocks[currentIndex][currentSubIndex]).setPDVariablePointer(currentVariableIndex);
addBlankBlockToCurrentStack();
}
function addBlankBlockToCurrentStack()
{
currentSubIndex++;
equationIndentTracker[equationIndentLevel].setCurrentLocation(currentSubIndex);
equationBlocks[currentIndex][currentSubIndex]=new PDBlock();
}
function addOperatorToStack(operatorToAdd)
{	
if (currentSubIndex==0 && (operatorToAdd=='*' || operatorToAdd=='/')) {
errorMessage=operatorToAdd+" near ( or beginning of the equation.";
return;
}
(equationBlocks[currentIndex][currentSubIndex]).setOperator(operatorToAdd);
}
function setBlockNegative()
{
(equationBlocks[currentIndex][currentSubIndex]).setBlockNegative(1);
}
function setBlockFunction(functionNumber)
{
(equationBlocks[currentIndex][currentSubIndex]).setPDFunction(functionNumber);
}
function setCurrentBlockPointer(number)
{
(equationBlocks[currentIndex][currentSubIndex]).setBlockPointer(number);
}
function currentBlockHasOperator()
{
return (equationBlocks[currentIndex][currentSubIndex]).getOperator();
}
function incrementBlockIndent()
{
addBlankBlockToCurrentStack();
currentSubIndex--;
var parentIndexToSet=currentIndex;
var parentSubIndexToSet=currentSubIndex;
var newBlockIndex;
if (equationBlocks[currentIndex][currentSubIndex].getOperator()==false && currentSubIndex!=0 && equationToCalculate.charAt(equationPosition-1)!='(' ) {
errorMessage="Error near "+masterEquation.charAt(equationPosition-1)+"(.";
return;
}
equationIndentLevel++;
equationIndentTracker[equationIndentLevel]=new PDPosition();	
newBlockIndex=equationBlocks.length;
equationBlocks[newBlockIndex]=new Array();
equationBlocks[newBlockIndex][0]=new PDBlock();
setCurrentBlockPointer(newBlockIndex);
equationIndentTracker[equationIndentLevel].setMainIndex(newBlockIndex);
equationBlockInfo[newBlockIndex]=new PDBlockInfo();
(equationBlockInfo[newBlockIndex]).setParent(parentIndexToSet);
(equationBlockInfo[newBlockIndex]).setParentSubIndex(parentSubIndexToSet);
currentIndex=newBlockIndex;
currentSubIndex=0;
}
function decrementBlockIndent()
{
equationIndentLevel--;
if (equationIndentLevel<0) {
errorMessage="Unbalanced parenthesis.";
return;
}
currentSubIndex=equationIndentTracker[equationIndentLevel].getCurrentLocation();
currentIndex=equationIndentTracker[equationIndentLevel].getMainIndex();
}
function verifyBlockIndent()
{
if (equationIndentLevel!==0) {
errorMessage='Unbalanced parenthesis.'
}
}
function reduceExponents(blockNumber)
{
var exponentArray=new Array(), j=0, initialExponentIndex, runningTotal;
var negativeArray=new Array();
for (i=0; i<equationBlocks[blockNumber].length; i++) {
while ((equationBlocks[blockNumber][i]).getOperator()=='^') {
if (!j) { 
initialExponentIndex=i-1; 
exponentArray[j]=(equationBlocks[blockNumber][initialExponentIndex]).getNumber();
negativeArray[j]=(equationBlocks[blockNumber][initialExponentIndex]).getBlockNegative();
j++;
}
exponentArray[j]=(equationBlocks[blockNumber][i]).getNumber();
negativeArray[j]=(equationBlocks[blockNumber][i]).getBlockNegative();
j++;
i++;
}
if (j) { 
j=exponentArray.length-1;
runningTotal=exponentArray[j];			
for (j=j-1; j>-1; j--) {
if (negativeArray[j]) {
runningTotal=-1*Math.pow(-1*exponentArray[j], runningTotal);
} else {
runningTotal=Math.pow(exponentArray[j], runningTotal);
}
}
if (!isFinite(runningTotal)) {
errorMessage='Exponent near '+exponentArray[0]+'^'+exponentArray[1]+" too large.";
runningTotal=0; 
}
j=exponentArray.length;
(equationBlocks[blockNumber][initialExponentIndex]).resetNumber(runningTotal);
(equationBlocks[blockNumber]).splice(initialExponentIndex+1, j-1);
i=initialExponentIndex;
exponentArray=new Array();
j=0;
}
}
}
function reduceFunctions(blockNumber)
{
var i, functionNumber, currentNumber, currentMasterNumber, result, currentPointer;
var currentStackIndex, currentNumber;
for (i=0; i<equationBlocks[blockNumber].length; i++) {
functionNumber=(equationBlocks[blockNumber][i]).getPDFunction();
if (functionNumber) { 
currentPointer=(equationBlocks[blockNumber][i]).getBlockPointer(); 
if ((equationBlockInfo[currentPointer].getReducedToNumber())) { 
currentNumber=(equationBlocks[currentPointer][0]).getNumber();
currentMasterNumber=(equationBlocks[currentPointer][0]).getMasterNumber();
result=calculatePDFunction(currentNumber, currentMasterNumber, functionNumber);
(equationBlocks[blockNumber][i]).replaceWithResultOfPDFunction(result);
} 
}
}
}
function reduceMDAS(blockNumber) 
{
var currentNumber, nextNumber, currentOperator, nextOperator;
var mDRunningComputation, runningComputation=0, i=0;
for (i=0; i<equationBlocks[blockNumber].length-1; i++) {
currentNumber=(equationBlocks[blockNumber][i]).getNumber();
currentOperator=(equationBlocks[blockNumber][i]).getOperator();
nextNumber=(equationBlocks[blockNumber][i+1]).getNumber();
nextOperator=(equationBlocks[blockNumber][i+1]).getOperator();
if ((nextOperator=='+' || nextOperator=='-' || !nextOperator) && (currentOperator=='+' || currentOperator=='-' || !currentOperator)) {
if (currentOperator=='+' || !currentOperator) { 
runningComputation+=currentNumber; 
} else if (currentOperator=='-') { 
runningComputation-=currentNumber; 
}
} else if (nextOperator=='*' || nextOperator=='/' || nextOperator=='%') { 
mDRunningComputation=currentNumber;
while (nextOperator=='*' || nextOperator=='/' || nextOperator=='%') { 
nextNumber=(equationBlocks[blockNumber][i+1]).getNumber();
nextOperator=(equationBlocks[blockNumber][i+1]).getOperator();
i++;
if (nextOperator=='*') { 
mDRunningComputation*=nextNumber;
} else if (nextOperator=='/') {
mDRunningComputation=mDRunningComputation/nextNumber;
} else if (nextOperator=='%') {
mDRunningComputation=mDRunningComputation%nextNumber;
}
}
i--; 
if (currentOperator=='+' || !currentOperator) {
runningComputation+=mDRunningComputation;
} else if (currentOperator=='-') {
runningComputation-=mDRunningComputation;
}
}
}
i=equationBlocks[blockNumber].length;
(equationBlocks[blockNumber][0]).resetNumber(runningComputation);
(equationBlocks[blockNumber]).splice(1, i-2);
(equationBlockInfo[blockNumber]).setReducedToNumber(true);
}
function reduceEquation()
{
var i;
markedReducedBlocks();
for (i=equationBlocks.length-1; i>-1; i--) {
reduceFunctions(i);
reduceExponents(i);
reduceMDAS(i);	
replaceBlockInParent(i);
}
}
function replaceBlockInParent(blockNumber)
{
var parent=equationBlockInfo[blockNumber].getParent();
var parentSubIndex=equationBlockInfo[blockNumber].getParentSubIndex();
if (parent!==false && (equationBlocks[parent][parentSubIndex]).getPDFunction()===0) {
equationBlocks[parent][parentSubIndex].replaceWithPDBlockResult(equationBlocks[blockNumber][0].getNumber());		
}
}
function markedReducedBlocks()
{
var i;
for (i=0; i<equationBlocks.length; i++) {
if ((equationBlockInfo[i]).getReducedToNumber()==false && (equationBlocks[i][0]).isNumberOnly()==true && (equationBlocks[i][1]).isInitialized()==false) {
(equationBlockInfo[i]).setReducedToNumber(true);
}
}
}
function markBlockAsFinished(blockPointer)
{
equationBlockInfo[blockPointer].markAsFinished();
}
function calculatePDFunction(currentNumber, currentMasterNumber, functionNumber)
{
var result, tempRoundingNumber;
if (!preferencesRadians) {
if (functionNumber==2 || functionNumber==3 || functionNumber==4 || functionNumber==6 || functionNumber==7 || (functionNumber>=10 && functionNumber<=16)) {
currentNumber=currentNumber*Math.PI/180;
}
}
switch(functionNumber) {
case 1:
result=Math.exp(currentNumber);
break;
case 2:
result=formatTrigFunction(Math.sin(currentNumber));
break;
case 3:
result=formatTrigFunction(Math.cos(currentNumber));
break;
case 4:
result=formatTrigFunction(Math.tan(currentNumber));
break;
case 5:
result=Math.sqrt(currentNumber);
break;
case 6: 
result=(Math.exp(currentNumber)-Math.exp(-currentNumber))/2;
break;
case 7: 
result=(Math.exp(currentNumber)+Math.exp(-currentNumber))/2;
break;
case 8: 
result=Math.log(currentNumber);
break;
case 9: 
result=Math.log(currentNumber)/Math.LN10;
break;
case 10: 
result=(Math.exp(currentNumber)-Math.exp(-currentNumber))/(Math.exp(currentNumber)+Math.exp(-currentNumber));
break;
case 11: 
result=1/formatTrigFunction(Math.sin(currentNumber));
break;
case 12: 
result=1/formatTrigFunction(Math.cos(currentNumber));
break;
case 13: 
result=1/Math.tan(currentNumber);
break;
case 14: 
result=2/(Math.exp(currentNumber)-Math.exp(-currentNumber));
break;
case 15: 
result=2/(Math.exp(currentNumber)+Math.exp(-currentNumber));
break;
case 16: 
result=(Math.exp(currentNumber)+Math.exp(-currentNumber))/(Math.exp(currentNumber)-Math.exp(-currentNumber));
break;
case 17:
result=Math.asin(currentNumber);
break;
case 18:
result=Math.acos(currentNumber);
break;
case 19:
result=Math.atan(currentNumber);
break;
case 20:
result=parseInt(currentNumber, 2);
if (isNaN(result)) {
errorMessage=currentNumber+" is not a valid binary number";
result=0; 
}
break;
case 21:
result=Math.pow(currentNumber, 1/3);
break;
case 22:
tempRoundingNumber=new PDRoundingNumber();
tempRoundingNumber.setRoundingNumber(currentNumber);
currentNumber=tempRoundingNumber.getNoiselessNumber();
result=Math.floor(currentNumber);
break;	
case 23:
tempRoundingNumber=new PDRoundingNumber();
tempRoundingNumber.setRoundingNumber(currentNumber);
currentNumber=tempRoundingNumber.getNoiselessNumber();
result=Math.ceil(currentNumber);
break;	
case 24:
tempRoundingNumber=new PDRoundingNumber();
tempRoundingNumber.setRoundingNumber(currentNumber);
currentNumber=tempRoundingNumber.getNoiselessNumber();
result=Math.round(currentNumber);
break;	
case 25:
result=parseInt(currentNumber, 8);
break;
case 26:
result=parseInt(currentNumber, 16);
break;
}
if (!preferencesRadians) { 
if (functionNumber>=17 && functionNumber<=19) {
result=result*180/Math.PI;
}
}
return result;
}
function formatTrigFunction(trigcalctemp)
{
var trigcalcfinal=trigcalctemp;
var zerotolerance=1e-13;
if (trigcalctemp<=zerotolerance && trigcalctemp>=-zerotolerance) { 
trigcalcfinal=0;
} else if (trigcalctemp<=1+zerotolerance && trigcalctemp>=1-zerotolerance) {
trigcalcfinal=1;
}
return trigcalcfinal;
}
function setVariable(currentVariableName, currentVariableValue)
{
var currentVariableIndex=getVariableIndex(currentVariableName);
if (currentVariableIndex!=-1) { 
PDVariables[currentVariableIndex].setValue(currentVariableValue);
} else { 
currentVariableIndex=PDVariables.length;
PDVariables[currentVariableIndex]=new PDVariable();
PDVariables[currentVariableIndex].setValue(currentVariableValue);
PDVariableNames[currentVariableIndex]=currentVariableName;
}
}
function getVariableIndex(variableName)
{
var i=0, variableNamesLength=PDVariableNames.length;
while (i<variableNamesLength) {
if (PDVariableNames[i++]==variableName)
return (i-1);
}
return -1;
}
function isValidVariable(variableName)
{
var i=0, variableLength=variableName.length, currentKeycode=variableName.charCodeAt(0), alphaCount=0;
if (variableLength===0) {
errorMessage='Undefined variable.'
return false;
}
if (currentKeycode>47 && currentKeycode<58) {
errorMessage=variableName+' must start with a letter.'
return false;
}
if (parseFunction(variableName)) {
errorMessage=variableName+' is already a function.'
return false;
}	
if (variableName=='pi' || variableName=='ans' || variableName=='e' || variableName=='E') {
errorMessage=variableName+' is locked.';
return false;
}
while (i<variableLength) {
currentKeycode=variableName.charCodeAt(i);
if (currentKeycode>47 && currentKeycode<58); 
else if ((currentKeycode>64 && currentKeycode<91) || (currentKeycode>96 && currentKeycode<123) || (currentKeycode>191 && currentKeycode<256 && currentKeycode!=215 && currentKeycode!=237)) 
alphaCount++;
else {
errorMessage=variableName+' must be alphanumeric.'
return false;	
}	
i++;	
}
if (alphaCount===0) {
errorMessage='Variables cannot be numbers.'
return false;
}
return true;
}
function isVariableName(variableName)
{
var i=0, variableLength=variableName.length, currentKeycode=variableName.charCodeAt(0), alphaCount=0;
if (variableLength===0) {
return false;
}
if (currentKeycode>47 && currentKeycode<58) {
return false;
}
if (parseFunction(variableName)) {
return false;
}	
while (i<variableLength) {
currentKeycode=variableName.charCodeAt(i);
if (currentKeycode>47 && currentKeycode<58); 
else if ((currentKeycode>64 && currentKeycode<91) || (currentKeycode>96 && currentKeycode<123) || (currentKeycode>191 && currentKeycode<256 && currentKeycode!=215 && currentKeycode!=237)) 
alphaCount++;
else {
return false;	
}	
i++;	
}
if (alphaCount===0) {
return false;
}
return true;
}
function addComment(comment)
{
}
function removeSpaces(stringToWorkOn) 
{
var tempString='', stringToWorkOnLength, i;
stringToWorkOnLength=stringToWorkOn.length;
for (i=0; i<stringToWorkOnLength; i++) { 
if (stringToWorkOn.charCodeAt(i)!=160) {
tempString=tempString+''+stringToWorkOn.charAt(i);
}
}
return tempString;
}
